

#include "main_modbus.h"


void signalHandler(int signal);



#define _POSIX_SOURCE 1 // POSIX compliant source 
#define FALSE 0
#define TRUE 1



 
int continuer = 1;




// Fonction principale
int main(int argc, char *argv[])
{
	struct sigaction action, oldAction;
	int lu = 0, i = 0;
	unsigned char tab[1000] = {0};
	uint64_t ts = 0;
	
	// Mise de place de la détection du Ctrl C (SIGINT)
	action.sa_handler = signalHandler;
	sigemptyset(&action.sa_mask);
	action.sa_flags = SA_RESTART;
	sigaction(SIGINT, &action, &oldAction); // Récupère SIGINT (CTRL C)
	sigaction(SIGTERM, &action, &oldAction); // Un peu pareil... SIGTERM
	
	// Ouverture du port série
	if(openport() == EXIT_SUCCESS)
		printf("openport() OK\n");
	else
		printf("openport() NOK\n");
	
	printf("\033[2J");
	
	// Boucle principale : assemble les trames et appelle la fonction de décodage pour chacune
	while(continuer)
	{
		lu = readport();
		if(lu == -2)
		{
			printf("Problème de communication avec l'interface.\n");
			continuer = 0;
		}
		else if(lu >= 0) // Une donnée est reçue
		{
			uint64_t tmp = tsus();
			
			if(tmp - ts > 1800)
			{
				Decode_Trame_Modbus(tab, i);
				i = 0;
				//printf("\n\n\n\n");
			}
			
			tab[i++] = lu;
			
			//printf("0x%x ", lu);
			ts = tmp;
			//printf("Recu %d\n", i);
		}
		
		
	}
	//for(i = 0; i < 256; i++)
	//{
		//printf("%d\t%d\n", i, tab[i]);
	//}
    
    return 0;
}






// Fonction de reception des signaux, dont SIGINT
void signalHandler(int signal)
{
	if(signal == SIGINT)
		continuer = 0;
	
	
	if(signal == SIGTERM)
		continuer = 0;
	
	
	if(signal == SIGPIPE)
	{
		// ne rien faire
	}
}
 


