
#ifndef MODBUS_AFFICHAGE_H_
#define MODBUS_AFFICHAGE_H_



#define NB_MAX_ESCLAVES             5
#define NB_MAX_ADRESSES             1050

#define COULEURS_ACTIVES            1

#define DUREE_NOUVEAU_REGISTRE      1 // temps en seconde pendant lequel un registre changé est mis en surbrillance
#define TIMEOUT_REGISTRE            5




// Adaptation pour compilation sur STM32 et PC
/*#ifndef time_t
#define time_t uint32_t
#endif

#define time(NULL) (HAL_GetTick()/1000)*/


// Structure stockant un registre avec les infos associées
struct registre_t
{
	uint16_t valeur;
	int type_acces;
	time_t dernier_rx;
	time_t dernier_cht;
};




// macro pour la gestion des couleurs
#if COULEURS_ACTIVES == 1

	#define ROUGE    "31"
	#define VERT     "32"
	#define MAGENTA  "35"
	#define JAUNE    "33"
	#define CYAN     "36"
	#define BLANC    "0"
	
    #define COULEUR(param) printf("\033[%sm",param)
#else
    #define COULEUR(param) 
#endif	





// Réinitialise l'affichage
void Aff_Init();
void Aff_Trame(unsigned char * tab, int len);
void Aff_Trame_Invalide();
void Init_Registres();
void Aff_Nouvel_Esclave(int nouvel_esclave);
void Nettoie_Registres();
void Recoit_Registre(int num_esclave, int adresse, int valeur, int type_acces);
void Aff_Registres();

#endif


